use utf8;
use strict;
use warnings FATAL => 'all';

package Xyzzy::Database::Config;

use Xyzzy::Spiffy -Base;

use Xyzzy::Database::Transaction;

field 'db_type' => 'Pg';
field 'db_name';
field 'db_user';
field 'db_pass';

*set_db_type = *db_type;
*set_db_name = *db_name;
*set_db_user = *db_user;
*set_db_pass = *db_pass;

sub db_datasource {
	return $self->{db_datasource} = $_[0] if @_;
	return $self->{db_datasource} if exists $self->{db_datasource};

	my $type = $self->db_type // confess "undefined type";
	my $name = $self->db_name // '';
	return "dbi:$type:dbname=$name"
}

*set_db_datasource = *db_datasource;

field 'db_options' => {
	PrintError => 0,
	RaiseError => 1,
	AutoCommit => 0,
	ShowErrorStatement => 1,
	pg_enable_utf8 => 1
};
